{This file was processed by Dan's Source Converter}
{version 1.3 (this version modified by Ingemar Ragnemalm)}
{converted to Pascal by Matthew Xavier Mora mxmora@apple.com}
{ 12-9-96 Tested on 9500/180MP}

program MPHelloWorld;

	uses
		Types, Memory,QuickDraw,Fonts,Windows,Menus,TextEdit,Dialogs,MP;
	var
		err: Integer;
{------------------------------------------------------------------------}
	procedure InitMac;
{------------------------------------------------------------------------}
	begin
		InitGraf(@qd.thePort);
		InitFonts; 		{ foreground only }
		InitWindows; 	{ foreground only }
		InitMenus; 		{ foreground only }
		TEInit; 		{ foreground only }
		InitDialogs(nil); { foreground only }
		{SetApplLimit(sp-stack_size);} {Don't do this on PPC}
		MaxApplZone;
		MoreMasters;
		MoreMasters;
	end;

{------------------------------------------------------------------------}
	procedure sendString (queue: MPQueueID; var theString: Str255);
{------------------------------------------------------------------------}
{  Send the string through the queue one character at a time.}
		var
			err: OSStatus;
			i: integer;
			theChar: char;
	begin

		for i := 1 to integer(theString[0]) do
			begin
				theChar := thestring[i];
				err := MPNotifyQueue(queue, longint(theChar), nil, nil);
			end;
		theChar := chr(0);
		err := MPNotifyQueue(queue, longint(theChar), nil, nil);			(* Send the final null character. *)
	end;

{------------------------------------------------------------------------}
	procedure receiveString (queue: MPQueueID; var thestring: Str255);
{------------------------------------------------------------------------}
{  Reassemble a string being transferred over the queue and return it to the caller.}
	var
		first	: longint;		{* The first word of the message. *}
		second	: longint;		{* The second word of the message. *}
		third	: longint;		{* The third word of the message. *}
		i		: integer;
		err		: integer;

	begin
		i := 1;
		while (true) do
			begin
				err := MPWaitOnQueue(queue, @first, @second, @third, kDurationForever);

				if (first = 0) then
					begin
						theString[0] := char(i - 1);
						exit(receiveString);
					end
				else
					begin
						theString[i] := char(first);
					end;
				i := i + 1;
			end;
	end;

{------------------------------------------------------------------------}
	function HelloWorld (parameter: MPQueueID): OSStatus;
{------------------------------------------------------------------------}
	var
		queue: MPQueueID;
		tempStr: Str255;
		count:longint;
	begin
		queue 	:= parameter;
		tempStr := 'Hello, World from Pascal!';
		count	:= MPProcessors;
		tempStr := tempStr +  chr(13) + 'Processors: ' + stringof(count); {not sure if stringof is safe to cakll here}
		sendString(queue, tempStr);
		HelloWorld := noErr;
	end;

{------------------------------------------------------------------------}
	function failure (var annotation: Str255; routine: Str255; status: OSStatus): Integer;
{------------------------------------------------------------------------}
	var
		tempStr: Str255;
		itemHit: integer;
	begin
(*	printf('Uh oh.  %s%s%s returned %s [%d].\n',}
{         (annotation) ? annotation : '',}
{         (routine) ? routine : '',}
{         (routine) ? '()' : 'A routine',}
{         _MPStatusCString(status),}
{         status);}
{*)


{}
	{tempStr:=_MPStatusPString(status);}

		DebugStr(annotation);

{	ParamText(tempStr,'','','');}
{	itemHit:=Alert(128,nil);}

		failure := 1;
	end;

{------------------------------------------------------------------------}
	function Test: Integer;
{------------------------------------------------------------------------}
	var
		status, err: OSStatus;					(* We'll use this to test the outcome of each MP function. *)
		terminationQueue: MPQueueID;		(* This queue will report the completion of the task. *)
		communicationQueue: MPQueueID;	(* This queue will be used to communicate between the app and the task. *)
		task: MPTaskID;						(* This will be the ID of the task we create. *)
		myString: Str255;
		itemHit: Integer;
		tempStr: Str255;

	begin

		if (not MPLibraryIsLoaded) then
			begin
				ParamText('Can''t run without the ', MPLibraryPName, ' shared library.', '');
				itemHit := Alert(129, nil);
				exit(Test);
			end;

		status := MPCreateQueue(terminationQueue);	(* Create the queue which will report the completion of the task. *)
		if (status <> noErr) then
			begin
				tempStr := 'Cannot create the termination queue:\n';
				Test := failure(tempStr, 'MPCreateQueue', status);
				exit(Test);
			end;

		status := MPCreateQueue(communicationQueue);	(* Create the queue we'll use to communicate with. *)
		if (status <> noErr) then
			begin
				err := MPDeleteQueue(terminationQueue);
				tempStr := 'Cannot create the communication queue:\n    ';
				Test := failure(tempStr, 'MPCreateQueue', status);
				exit(Test);
			end;

		status := MPCreateTask(HelloWorld, communicationQueue, kMPUseDefaultStackSize, terminationQueue, nil, nil, kMPNormalTaskOptions, task);				(* This is the task function. *)
	(* This is the parameter to the task function. *)
	(* We'll use whatever the MP system software gives us. *)
	(* We'll use this to sense task completion. *)
	(* We won't use the first part of the termination message. *)
	(* We won't use the second part of the termination message. *)
	(* Use the normal task options. (Currently this *must* be zero!) *)
	(* Here's where the ID of the new task will go. *)

		if (status <> noErr) then
			begin
				err := MPDeleteQueue(terminationQueue);
				err := MPDeleteQueue(communicationQueue);
				tempStr := '';
				Test := failure(tempStr, 'MPCreateTask', status);
				exit(Test);
			end;

		receiveString(communicationQueue, myString);
		ParamText(myString, 'brought to you by Matthew Xavier Mora mxmora@apple.com', 'Developer Technical Support,', 'MW Pascal and MP.p interfaces');

		itemHit := Alert(128, nil);

  { Wait for the task to complete: }
		status := MPWaitOnQueue(terminationQueue, nil, nil, nil, kDurationForever);
		if (status <> noErr) then
			begin
				tempStr := 'While waiting for task completion:\n    ';
				err := failure(tempStr, 'MPWaitOnQueue', status);
			end;

		status := MPDeleteQueue(terminationQueue);
		if (status <> noErr) then
			begin
				tempStr := 'Can''t delete the termination queue:';
				err := failure(tempStr, 'MPDeleteQueue', status);
			end;

		status := MPDeleteQueue(communicationQueue);
		if (status <> noErr) then
			begin
				tempStr := 'Can''t delete the communication queue: ';
				err := failure(tempStr, 'MPDeleteQueue', status);
			end;

		Test := 0;
		Exit(Test);
	end;

{------------------------------------------------------------------------------------}
{Start of main}
{------------------------------------------------------------------------------------}
begin
	InitMac;
	err := Test;
end.